const GMenu = imports.gi.GMenu;
const Lang = imports.lang;
const Main = imports.ui.main;
const Shell = imports.gi.Shell;

let appView;
let setVisibleAppsOld, refreshOld;

function setVisibleApps(apps) {
    if (apps == null) {
        // Find System category
        let tree = Shell.AppSystem.get_default().get_tree();
        let iter = tree.get_root_directory().iter();
        let nextType;
        let system = 0;
        while ((nextType = iter.next()) != GMenu.TreeItemType.INVALID) {
            if (nextType == GMenu.TreeItemType.DIRECTORY) {
                let dir = iter.get_directory();
                if (dir.get_is_nodisplay())
                    continue;
                if (dir.get_menu_id() == "System")
                    break;
                system++;
            }
        }

        // Skip System category
        let cats = appView._categories;
        apps = new Array();
        for (let c in cats.slice(0, cats.length))
            if (c != system)
                apps = apps.concat(cats[c].apps);
    }
    setVisibleAppsOld.apply(appView._view, [apps]);
}

function init() {
    appView = Main.overview._viewSelector._appDisplay._appView;
    setVisibleAppsOld = appView._view.setVisibleApps;
    refreshOld = appView.refresh;
}

function enable() {
    appView._view.setVisibleApps = setVisibleApps;
    appView.refresh = function () {
            appView._currentCategory = -2;
            Lang.bind(appView, refreshOld)();
        }
}

function disable() {
    appView._view.setVisibleApps = setVisibleAppsOld;
    appView.refresh = refreshOld;
}
